/* CGBdemo 3rd mix! Programed by BouKiChi */

#include <gb.h>
#include "barchr.c"

unsigned char attrdata[30];

void set_attr(void)
{
        unsigned char x,y;
        VBK_REG = 1; /* VRAM Bank = 1; */
        for(x=0; x < 20; x++) {  
                for(y=0; y < 18; y++) {
                        attrdata[y]=(x/4)&7;  
                }
                set_bkg_tiles(x,0,1,18,attrdata);
        }
        VBK_REG = 0; /* VRAM Bank = 0; */
}

void set_bkg(void)
{
        unsigned char x,y;
        set_bkg_data(0,4,barchr);
        for(x=0; x < 20; x++) {  
                for(y=0; y < 18; y++) {
                        attrdata[y]=(x&3);  
                }
                set_bkg_tiles(x,0,1,18,attrdata);
        }
        SHOW_BKG;
}

unsigned char cptr;
unsigned char cmplines[]={0x10,0x20,0x30,0x40,0x50,0x60,0x70,0x80,0x88,0xFF};

char scrofs[12];
unsigned char adscr[12];

void LCDintr()
{
  cptr++;
  while((STAT_REG & 0x3) != 3);
  LYC_REG=cmplines[cptr];
  adscr[cptr]=adscr[cptr]+scrofs[cptr];
  SCX_REG=adscr[cptr];
}

void VBLintr()
{
  cptr=0;
  LYC_REG=cmplines[cptr];
  adscr[cptr]=adscr[cptr]+scrofs[cptr];
  SCX_REG=adscr[cptr];
}

#define PALCALC(r,g,b) ((r&0x1F)|(((UWORD)g&0x1F)<<5)|(((UWORD)b&0x1F)<<10))

void colorchg(unsigned char sel)
{
  unsigned long     pal[4]    ={0x001F,0x03E0,0x7C00,0x001F};
  unsigned char i,j;

  for(i=0; i < 20; i+=4) {
      for(j=0; j < 4; j++) {
          switch(sel) {
              case 0:
                   pal[j]=PALCALC(0,0,(i+j));
              break;
              case 1:
                   pal[j]=PALCALC(0,0x1F-(i+j),0);
              break;
              case 2:
                   pal[j]=PALCALC(0,0,0x1F-(i+j));
              break;
              case 3:
                   pal[j]=PALCALC(0x1F-(i+j),
                                  (i+j),
                                  0x1F-(i+j));
              break;
              case 4:
                   pal[j]=PALCALC(11+(i+j),(i+j),0);
              break;
              case 5:
                   pal[j]=PALCALC((i+j),11+(i+j),21-(i+j));
              break;
          }
      }
      set_bkg_palette( 7-((i/4)&7),1,&pal[0]);
  }
}

void main(void)
{
  unsigned long i,k;
  unsigned char j;
  unsigned char c,sel,sw;

  colorchg(0);

  set_attr();
  set_bkg();

  /* if( _cpu!=0x11 ) {
        while(1);
  }  */

  disable_interrupts();

  LYC_REG=0xFF; /* don't interrupt */
  cptr=0;

  add_LCD(LCDintr);
  add_VBL(VBLintr);

  enable_interrupts();

  set_interrupts(VBL_IFLAG | LCD_IFLAG);

  c=0;
  sel=1;
  SHOW_BKG;

  STAT_REG |= 0x40; /* if (LCDY==CY) LCDintr(); */
  do {

  switch(c) {
    case 0:
      disable_interrupts();
      for(j=0; j < 10; j++) scrofs[j]=10-j;
      for(j=0; j < 10; j++) adscr[j]=0;
      enable_interrupts();
    break;
    case 1:
      disable_interrupts();
      for(j=0; j < 10; j++) scrofs[j]=1;
      for(j=0; j < 10; j++) adscr[j]=j*8;
      enable_interrupts();
    break;
    case 2:
      disable_interrupts();
      for(j=0; j < 10; j++) scrofs[j]=j;
      for(j=0; j < 10; j++) adscr[j]=0;
      enable_interrupts();
    break;
    case 3:
      disable_interrupts();
      for(j=0; j < 10; j++) scrofs[j]=5-j;
      for(j=0; j < 10; j++) adscr[j]=0;
      enable_interrupts();
    break;
  }
  c++; c&=3;

  while(sw & J_A) sw=joypad();

  do {

    sw=joypad();
    if (sw & J_B) {
        colorchg(sel++); if (sel > 5) sel=0;
        while(sw & J_B) sw=joypad();
    }
    if (sw & J_LEFT) {
      for(j=0; j < 10; j++) scrofs[j]--;
      i=0;
      while(sw & J_LEFT && i < 300) {i++; sw=joypad();}
    }
    if (sw & J_RIGHT) {
      for(j=0; j < 10; j++) scrofs[j]++;
      i=0;
      while(sw & J_RIGHT && i < 300) {i++; sw=joypad();}
    }

  }while(!(sw & J_A));

  }while(1);
}

